import { Column, Entity } from 'typeorm';
import { CommonEntity } from './_common.entity';

@Entity('conversation')
export class ConversationEntity extends CommonEntity {
  @Column({
    type: 'varchar',
    default: '',
  })
  name: string;

  @Column({
    type: 'text',
    default: '{}',
  })
  avatar: string;

  @Column({
    type: 'bigint',
  })
  last_message_id: string;

  @Column({
    type: 'timestamp',
  })
  last_activity: Date;

  @Column({
    type: 'smallint',
    default: 0, // 0 - system, 1 - group, 2 - private
  })
  type: number;

  @Column({
    type: 'bigint',
    array: true,
  })
  members: string[];

  @Column({
    type: 'text',
    default: '{}',
  })
  background: string;

  @Column({
    type: 'smallint',
  })
  no_of_member: number;

  @Column({
    type: 'smallint',
    default: 0,
  })
  no_of_pinned: number;

  @Column({
    type: 'int',
    default: 0,
  })
  no_of_image: number;

  @Column({
    type: 'int',
    default: 0,
  })
  no_of_video: number;

  @Column({
    type: 'int',
    default: 0,
  })
  no_of_file: number;

  @Column({
    type: 'int',
    default: 0,
  })
  no_of_link: number;

  @Column({
    type: 'int',
    default: 0,
  })
  no_of_audio: number;

  @Column({
    type: 'varchar',
    default: '',
  })
  link_join: string;

  // @Column({
  //   type: 'bigint',
  //   default: 0,
  //   nullable: true,
  // })
  // message_pinned_id: number;

  @Column({
    type: 'smallint',
    default: 0,
  })
  is_user_remove: number;

  @Column({
    type: 'smallint',
    default: 0,
  })
  is_update_profile: number;

  @Column({
    type: 'smallint',
    default: 0,
  })
  is_create_reminder: number;

  @Column({
    type: 'smallint',
    default: 0,
  })
  is_create_vote: number;

  @Column({
    type: 'smallint',
    default: 0,
  })
  is_confirm_new_member: number;

  @Column({
    type: 'smallint',
    default: 0,
  })
  is_highlight_message_admin: number;

  @Column({
    type: 'smallint',
    default: 0,
  })
  is_view_old_message_with_new_member: number;

  @Column({
    type: 'smallint',
    default: 1,
  })
  is_join_with_link: number;

  @Column({
    type: 'smallint',
    default: 1,
    nullable: true,
  })
  is_send_message: number;

  @Column({
    type: 'smallint',
    default: 1,
  })
  status: number;
}
